package com.example.springmockito;

import com.example.springmockito.model.Employee;
import com.example.springmockito.model.Response;

import com.fasterxml.jackson.databind.ObjectMapper;


import org.junit.Assert;
import org.junit.Before;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;


import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;
@SpringBootTest
class SpringMockitoApplicationTests {

	private MockMvc mockMvc;
	@Autowired
	private WebApplicationContext context;
	ObjectMapper om = new ObjectMapper();

	@BeforeEach
	public void setup() {
		mockMvc = MockMvcBuilders.webAppContextSetup(context).build();
	}

	@Test
	public void addEmployeeTest() throws Exception {
	Employee mockEmployee = new Employee();
	mockEmployee.setId(1);
	mockEmployee.setName("srikala");
	mockEmployee.setDept("IT");
	String jsonRequest = om.writeValueAsString(mockEmployee);
	MvcResult result = mockMvc.perform(
					post("/EmployeeService/addEmployee").contentType(MediaType.APPLICATION_JSON_VALUE).content(jsonRequest))
			.andExpect(content().string(jsonRequest))
			.andExpect(status().isOk())
			.andReturn();
	String resultContent = result.getResponse().getContentAsString();
	Employee employee = om.readValue(resultContent, Employee.class);
	Assert.assertTrue(mockEmployee.equals(employee));
}
	@Test
	public void getEmployeeTest() throws Exception {
		MvcResult result = mockMvc.perform(
						get("/EmployeeService/getEmployees").content(MediaType.APPLICATION_JSON_VALUE))
				.andExpect(status().isOk()).andReturn();
		String resultContent = result.getResponse().getContentAsString();
		Response response = om.readValue(resultContent, Response.class);
		Assert.assertTrue(response.isStatus() == Boolean.TRUE);






	}


















}
